function [M1, M2]=GenGameMatrixWithPunishment(n1,n2,lc1,lc2,tc1,tc2)
% M1 is the cost matrix of network 1
% M2 is the cost matrix of network 2
% n1 is the gateway number of network 1
% n2 is the gateway number of network 2
% lc1 is the gateway cost of network 1
% lc2 is the gateway cost of network 2
% tc1 is the route cost of network 1
% tc2 is the route cost of network 2
M1=zeros(n1*n2, n1*n2);
M2=zeros(n1*n2, n1*n2);
p1=1.2;
p2=1.5;
%p3=p2*p2;
for i=1:n1*n2
    for j=1:n1*n2
        g1=ceil(i/n2);
        g2=ceil(j/n1);
        l1=i-(g1-1)*n2;
        l2=j-(g2-1)*n1;
        if(g1==l2)
            M1(i,j)=lc1(l2)*p1+tc1(i)*p2;
%             if(l1==g2)
%                 M1(i,j)=lc1(l2)*p1+tc1(i)*p3;
%             else
%                 M1(i,j)=lc1(l2)*p1+tc1(i)*p2;
%             end
        else
            M1(i,j)=lc1(l2)+tc1(i);
        end
        if(g2==l1)
            M2(i,j)=lc2(l1)*p1+tc2(j)*p2;
%             if(l2==g1)
%                 M2(i,j)=lc2(l1)*p1+tc2(j)*p3;
%             else
%                 M2(i,j)=lc2(l1)*p1+tc2(j)*p2;
%             end
        else
            M2(i,j)=lc2(l1)+tc2(j);
        end
    end
end
